Assignee: Jean-Philippe Lang % Done: 100%

Category: Issues Estimated time: 0.00 hour

Target version: 2.2.0   

Resolution: Fixed   

Description

Hi,

private issues would be great, but I'd like to propose a feature taken from Request Tracker (a great tool btw).

In RT3, it's possible for admins of a queue (~= project in redmine) to add comments to a tickets. Comments are different from

answers in the way they can be viewed only by admin members.

Therefore, I can use those "hidden" comments to add info on tickets, and sometimes drive my team to the right path. For example,

sometimes I just want to make sure they understood correctly, and will only add this very little line at bottom of file to fix the issue.

Having such feature in redmine would be a real advantage for my company.

Thanks,

Philippe

Related issues:

Related to Redmine - Feature #337: Private issues Closed

Related to Redmine - Feature #7412: Add an issue visibility level to each role Closed 2011-01-22

Related to Redmine - Feature #11829: View Roadmap privilege New

Related to Redmine - Defect #12286: Emails of private notes are sent to watch... Closed

Related to Redmine - Feature #1193: Staff-only notes with Role-base access co... New 2008-05-06

Has duplicate Redmine - Feature #3037: Ability to filter updates in issue his... Closed 2009-03-24

Has duplicate Redmine - Feature #10788: More private posibilities Closed

Associated revisions

Revision 10547 - 2012-10-03 23:36 - Jean-Philippe Lang

Private issue notes (#1554).

Adds 2 new permissions for viewing/adding private comments to issues.

Revision 10548 - 2012-10-04 01:21 - Toshi MARUYAMA

update locale files (#1554)

Revision 10585 - 2012-10-09 21:11 - Jean-Philippe Lang

Fixed that issue notes preview is broken by r10547 (#1554).

History

#1 - 2008-06-30 23:03 - Philippe Lafoucrière

Funny, I can't find the option to add a relation to a ticket when the issue is created, it is a bug ??

This ticket can be related to #337

#2 - 2009-01-28 04:03 - Chris Cage

I'd like to second the desire for this feature. We've been using Bugzilla as our issue tracker some time now. Bugzilla has the ability for private issues

and private comments and I can say we use the private comments feature much more (although the private issue feature is helpful as well). Similar to

what Philippe mentioned, we use the private comments to create clarification or ask questions internally that we would rather not share with our

clients.
This actually has been the main issue causing us to hesitate in migrating to Redmine, although we will still probably jump in soon.

#3 - 2009-02-06 13:51 - Simon Stearn

+1

#4 - 2009-03-29 22:07 - Jens Goldhammer

+1. This would be very useful.

#5 - 2009-04-23 01:31 - Shaun Gilroy

We also could really use this functionality.  This actually more important than 'private issues'...

Seems to me that this could be handled pretty easily as a plugin...  Does anybody know of one that does this?

#6 - 2009-06-10 22:06 - Jens Goldhammer

JIRA uses a checkbox for marking a comment as private. I think, this would be a first quick hack.

#7 - 2009-06-11 09:47 - Szabolcs Klement

I make the following changes in app/models/journal.rb:

def notes

orignote=read_attribute(:notes).to_s

if (User.current.allowed_to?(:privnote, project)||self.user.to_s==User.current.to_s)||(aa[0..0]!='/')

orignot

else

"private note!"

end

end

when the first char is '/' then the note value is "private note"

the :privnote is a new permission in lib/redmine.rb:

map.permission :felelos_valasztas, :issues => :felelos_valasztas

But this solution is bad for the mail notification.

#8 - 2009-10-28 11:37 - chris madler

+1

I also think this feature is absolutely necessary for companies that want to keep some notes on issues only visible to staff members and other notes

(also) visible to clients.

I suppose it would consist of having a field "visibility" with values (private, public) on each note that is added to an issue. Then in roles, a permission

to view certain visibility values (private, public, or both?). Related to #1193.

#9 - 2009-10-28 11:44 - Philippe Lafoucrière

chris madler wrote:

I suppose it would consist of having a field "visibility" with values (private, public) on each note that is added to an issue. Then in roles, a

permission to view certain visibility values (private, public, or both?). Related to #1193.

 This might be more easy to use than having Comment / Reply models ?

On the other hand, since redmine has automatic notification, it sounds silly to change (=hide) a ticket update after a mail is sent, so the couple

Comment(hidden) / Reply(visible) should be considered too.

Thanks !

#10 - 2009-12-21 21:56 - Aron Rotteveel

+1 definately.

This feature would be an awesome addition. Currently we use Redmine for larger projects. Both our developers as customers have access to the

issue list and we have entire conversations regarding bugs/features in our applications. It would be great to have private comments that would be

visible for only certain users or usergroups. That way we would be able to include internal task assignments in the comments without our customers

being notified all the time.

#11 - 2010-01-24 12:18 - Mike Heininger

+1

#12 - 2010-02-15 11:27 - Jani Partanen
Philippe Lafoucrière wrote:

This might be more easy to use than having Comment / Reply models ?

On the other hand, since redmine has automatic notification, it sounds silly to change (=hide) a ticket update after a mail is sent, so the couple

Comment(hidden) / Reply(visible) should be considered too.

 How about new setting "private issues"

When selected, then all comments in private in default, until you click "Answer author" checkbox

Hows that sounds?

#13 - 2010-02-19 21:28 - Alex Popov

+1

#14 - 2010-04-06 16:14 - Ronald Theile

Any news on this feature?

We use now a "internal" and a external project to hide comments and development steps to the customer. But they have to be on same status, so it's

more work.

regards Ron

#15 - 2010-04-09 15:03 - Oleg Volkov

Feature #337 is updated for current trunk version.

#16 - 2010-04-09 15:09 - Philippe Lafoucrière

Great, thanks. Anyway, I want to make sure we're talking about the same thing. This issue is about private COMMENTS in tickets. It's somehow

related to #337, but they are really not the same feature request.

Thanks

Philippe

#17 - 2010-04-10 07:24 - Oleg Volkov

First you have to push in a trunk feature 337, then make private comments. Please test the feature 337.

#18 - 2010-04-10 08:40 - Oleg Volkov

Philippe Lafoucrière wrote:

Great, thanks. Anyway, I want to make sure we're talking about the same thing. This issue is about private COMMENTS in tickets. It's somehow

related to #337, but they are really not the same feature request.

 In the trunk version for private comments, it will create a subtask with a private issue.

#19 - 2010-04-21 13:29 - Oleg Volkov

I updated the # 337. Please test it.

Private notes are needed for NOT private issue?

Who should view private notes?

#20 - 2010-04-21 19:55 - Philippe Lafoucrière

Oleg Volkov wrote:

I updated the # 337. Please test it.

 Thanks Oleg, I'll test it.

Private notes are needed for NOT private issue?

 Yes, privates notes and private issues are 2 different things. A ticket can be "public" (not private) and have private notes.

Who should view private notes?

 This should be part of the roles configuration, but I'd say manager + developer. Generally, the reporter is the customer, they should not see private
comments.

An example of private comment :

1- John_the_customer opens an issue : "I can't login on the demo site"

2- Bill_the_dev_leader adds a private comment : "Check that this jerk has created an account on demo, and if the last database has been imported"

3- Bob_the_dev adds a reply : "John, we'll check if you an account on demo, and if everything is in place and let you know asap".

John should not see step 2 :)

#21 - 2010-04-21 20:53 - Oleg Volkov

Privileges "Hidden notes" for the possibility of adding / editing / viewing of hidden notes will be enough?

#22 - 2010-04-21 21:42 - Philippe Lafoucrière

Exactly!

Thanks

#23 - 2010-04-22 03:02 - Kioma Aldecoa

Would be great to have this feature, we'd also benefit greatly by being able to control which comments can be seen by customers.  We also

considered an internal/external project but this would be slow and cumbersome.

#24 - 2010-04-28 16:13 - Wytze Keuning

Would be very useful indeed. That way a person working on an issue can update the issue with information not visible for "plain" viewers. A discrete

comment so to speak.

#25 - 2010-05-13 14:09 - Ivo Leite

+1

#26 - 2010-05-24 10:40 - Pradeep Achan

+1

#27 - 2010-05-28 13:03 - Roland Discein

+1

#28 - 2010-06-23 16:25 - Grant Show

+1

#29 - 2010-07-09 17:07 - Eric Peterson

+1

#30 - 2010-07-23 21:37 - Matt Meng

+1

My organization is getting flustered with Redmine because there are no private comments.  This would be a very good addition for us.

#31 - 2010-07-26 13:41 - Karolina -

Thank you for private issue, now we are waiting for private comments.

#32 - 2010-09-13 19:40 - Darth Jesus

Is anyone investigating this? This feature would greatly enhance our support environment.

#33 - 2010-10-21 15:27 - Dan Scharon

Oleg Volkov wrote:

Privileges "Hidden notes" for the possibility of adding / editing / viewing of hidden notes will be enough?

 Yes, this would be absolutely sufficient, thus this one is not dependent on #337

#34 - 2010-12-09 15:08 - Heiko Robert

+1

2024-03-13 4/12

https://www.redmine.org/issues/337


#35 - 2010-12-22 23:51 - Ant Radford

+1

#36 - 2011-01-27 09:53 - Marcel Hochuli

+1

#37 - 2011-01-29 14:34 - Cord Bellersen

+1

Mantis has that feature as well and we are using it a lot. Our customers uses our issue management system and in almost every ticket we need to

discuss something, that the customer is not supposed to see.

#38 - 2011-03-14 12:53 - Karolina -

Can't wait for this feature!

#39 - 2011-03-22 09:28 - Yuke Priyantoko

+1

#40 - 2011-03-24 16:12 - David Gillard

+1 Is anyone on the Redmine team looking at putting this onto the roadmap? Thanks

#41 - 2011-04-18 18:12 - Etienne Massip

- Target version set to Candidate for next major release

#42 - 2011-04-29 10:35 - Brian Kjelin Olsen

+1 Thanks Etienne, I can't wait either :)

#43 - 2011-06-08 15:12 - Bartek W

+ me too

#44 - 2011-06-11 22:59 - Terence Mill

+1

#45 - 2011-06-30 11:56 - Christian Köwing

+1

#46 - 2011-07-06 01:46 - Royce Williams

+1

#47 - 2011-08-20 12:43 - Dmitry Polovka

- File private_messages.patch added

- File 20110820092133_add_private_to_journals.rb added

- % Done changed from 0 to 50

As Eugene Kharkov mentioned before http://www.redmine.org/boards/1/topics/4325?r=25789#message-25789 Ruby and Rails not our strong side, so

it would be nice if somebody of experienced Ruby developers cleaned up our code. We made patch from /branches/1.2-stable/ r6484 source code

and added one permission "View private messages" which allow you view and also add private messages.

#48 - 2011-08-28 15:43 - pasquale [:dedalus]

+1: necessary feature

#49 - 2011-08-29 22:41 - Pawel Orzechowski

+1:

#50 - 2011-09-03 19:51 - Jacob Weber

+1
#51 - 2011-09-05 13:27 - Jérôme BATAILLE

+1

#52 - 2011-09-16 13:00 - Sergey Kolodyazhnyy

+1

Please, implement this feature. My client shouldn't see programmer talks

#53 - 2011-09-22 17:07 - Anonymous

Dmitry Polovka wrote:

As Eugene Kharkov mentioned before http://www.redmine.org/boards/1/topics/4325?r=25789#message-25789 Ruby and Rails not our strong

side, so it would be nice if somebody of experienced Ruby developers cleaned up our code. We made patch from /branches/1.2-stable/ r6484

source code and added one permission "View private messages" which allow you view and also add private messages.

 What I have to do with 20110820092133_add_private_to_journals.rb ?

I successfull patched the source, but I don't know how to change the database. Even with an "alter table journals add column private tinyint(1) default

0;" I cannot create a new notice.

NoMethodError in Issues#show

Showing app/views/issues/show.rhtml where line #94 raised:

undefined method `private' for #<Journal:0x4f8ec5c>

#54 - 2011-10-05 15:55 - Chaim Peck

+1 Agreed - it would be very useful to be able to tag a comment as "private" or a drop-down that says "Make this comment viewable to: [All,

Managers, Developers, Reporters]

#55 - 2011-11-08 04:34 - Razi Baluchi

I've applied the patch to a 1.2.1 installation, and everything appears to work as expected with the exception of the activity log. This still shows all

comments, private and non-private. Is there a step I might have missed?

#56 - 2011-11-10 18:32 - Razi Baluchi

Resolved the activity log issue by adding:

        # The private notes should be removed from events

    events.delete_if { |e| e.is_a?(Journal) && e.private }

 to app/controllers/activities_controller.rb

#57 - 2011-12-05 11:57 - Ernesto Baschny

+1 on that feature...

Is anyone using the patch from Dmitry Polovka plus the additional change by Razi successfully? Is it safe to apply and try it out? Thanks!

#58 - 2011-12-14 03:46 - Shaun Gilroy

Razi Baluchi wrote:

Resolved the activity log issue by adding:

[...]

to app/controllers/activities_controller.rb

 This method of hiding the activity is going to hide the private notes regardless of whether you have permission to see them or not.  I'll fix it and post a

patch if I manage to fix it.

Shouldn't logic like this be going into the model, not the controller?

#59 - 2011-12-14 20:25 - Shaun Gilroy

- File private_messages-2011-12-14.patch added

Alright--

This patch is compatible with 1.2-stable, but they've changed a few filenames in 1.3, so I couldn't get it to work with 1.3 without taking more time than

I had on my hands today.
I've repaired a few things from the previous patch:

1. Emails from private messages include a '[PRIVATE]' value i the subject to warn the user

2. Incoming emails that update issues with '[PRIVATE]' in their subject will be added to the system as private notes (so you don't accidentally

respond to a private note with a public response)

3. I updated  Razi Baluchi's change above to Activity Lists to only hide private notes from users who do not have permission to view private notes.

I made no changes to the migration, so I'm not uploading a new migration file.

#60 - 2011-12-14 23:15 - Shaun Gilroy

- File private_messages-2011-12-14-v1.3.patch added

It bothered me to ditch on the 1.3 patch so quickly, so I went back and generated a 1.3 patch. Again, no new migration file was required. This should

get anyone who's deployed 1.3.x up and running.

#61 - 2011-12-19 21:58 - Alter Way

- Assignee set to Anonymous

I am a newby on ruby: How do you run 20110820092133_add_private_to_journals.rb  migration script ?

thx

#62 - 2011-12-19 22:13 - Alter Way

Forget my question i found how to do it

Alter Way wrote:

I am a newby on ruby: How do you run 20110820092133_add_private_to_journals.rb  migration script ?

thx

#63 - 2011-12-20 15:41 - Anonymous

Alter Way wrote:

I am a newby on ruby: How do you run 20110820092133_add_private_to_journals.rb  migration script ?

thx

 Please don't randomly assign tickets to people.

#64 - 2011-12-20 15:41 - Anonymous

- Assignee deleted (Anonymous)

#65 - 2012-01-05 15:10 - Pablo Bastari

- File patch_output.txt added

Nice feature you patched, but i am having problems to merge it with 1.3 stable i installed a few days ago. When i run the patch -p0 <

private_messages-2011-12-14-v1.3.patch  on the root dir of redmine and i get a lot of errors and rejected merges. Any idea why?

I am atacching the output of the patch.

Thanks.

#66 - 2012-01-05 18:02 - Shaun Gilroy

My initial thought is that you might not be running it from your redmine install directory.  I occasionally get error like that when I try to apply a patch

from ~/

This also might be caused if you've made modifications to redmine yourself or run a previous patch first. You really only need to run the last patch

posted.

#67 - 2012-03-20 06:46 - Deoren Moor

+1

I am really looking forward to this feature. I've been missing this since I last used Bugzilla years ago.

#68 - 2012-03-27 15:00 - Anonymous
+1 I really need this feature. Hope it will be included in the next release. But first i try the patch right now.

Patch doesn´t work. I get the same errors as Pablo Bastari http://www.redmine.org/issues/1554#note-65.

I am in the redmine root and didn´t modify it.

#69 - 2012-04-03 16:14 - marcin t

+1

#70 - 2012-05-03 13:09 - Leif Lodahl

+1

#71 - 2012-05-19 21:58 - José Campos

+1

#72 - 2012-06-10 23:05 - Joerg Oswald

+1 ASAP

We're using the 1.3.x patch. Can anybody please provide an update for 1.4.x?

Since this issue is +4 years old, who can push this issue from "Candidate for next major release" really to next major release?

#73 - 2012-06-29 22:19 - Ingo Linde

+1

Would be a huge step forward for our use case.

#74 - 2012-07-25 18:06 - Gabriel Pettier

- File 0001-add-private-messages.patch added

Applied manually (since it didn't apply cleanly) patch for 1.3 on my git version on 1.4 tag. did git format-patch HEAD^

patch attached, can be used with git apply 0001-add-private-messages.patch

#75 - 2012-07-30 05:11 - Ryan Cross

- Assignee set to Etienne Massip

patch looks good. Can this go into the next version?

#76 - 2012-07-30 19:23 - Etienne Massip

- Assignee deleted (Etienne Massip)

#77 - 2012-08-01 16:36 - Ulf Johansson

+1

This feature could make us replace Jira (one thing that we would like to see in redmine in order to make a transition)!

#78 - 2012-08-01 21:08 - Thomas Pihl

+1

#79 - 2012-08-03 18:20 - Vicky Dibble

How would I get the messages to be private by default? I.e. where the tickbox is shown, have it selected by default?

#80 - 2012-08-08 23:44 - Jean-Philippe Lang

- Target version changed from Candidate for next major release to 2.2.0

#81 - 2012-08-15 11:04 - Vicky Dibble

Vicky Dibble wrote:

How would I get the messages to be private by default? I.e. where the tickbox is shown, have it selected by default?

 I worked this out, if you edit

/opt/bitnami/apps/redmine/app/views/issues/_edit.html

And change 
<% if view_private >

       <= check_box_tag :private_message, true, false >

       <= label_tag :private_message, 'Private message', :style => 'font-weight:bold;' >

     < end %>

 to be

<% if view_private >

       <= check_box_tag :private_message, true, false, :checked => true >

       <= label_tag :private_message, 'Private message', :style => 'font-weight:bold;' >

     < end %>

 Then where the 'Private' check box for messages appears, it sets it as ticked.

I have set up and tested this in 1.4 with the patches above. Great work all told guys, and a massive plus for Redmine. Thanks!

#82 - 2012-08-15 17:07 - Terence Mill

This shall be configurable in global settings.

Also private issues default shall be configurable in global settings.

#83 - 2012-08-30 06:51 - Andrew Kirillov

- File restrict_view_private_messages_in_RSS_and_PDF_formats.patch added

Fixed output private messages in RSS and PDF formats.

#84 - 2012-09-18 14:14 - Martin S.

-1 for using just a flag for "private" vs. "non-private" as that is very limited...

+1 for a feature to be able to set the "visibility/viewing-restriction" of a comment to all users/a role/a group or even selected users.

#85 - 2012-09-22 12:04 - Jean-Philippe Lang

Martin S. wrote:

+1 for a feature to be able to set the "visibility/viewing-restriction" of a comment to all users/a role/a group or even selected users.

 This is overkill IMO. I'm not saying that it would be useless but still, this feature will be implemented as a simple flag in 2.2 and visibility configured on

each role.

#86 - 2012-09-22 16:16 - Michael Stucki

Jean-Philippe Lang wrote:

Martin S. wrote:

+1 for a feature to be able to set the "visibility/viewing-restriction" of a comment to all users/a role/a group or even selected users.

 This is overkill IMO. I'm not saying that it would be useless but still, this feature will be implemented as a simple flag in 2.2 and visibility

configured on each role.

 I agree. Let's make the basic functionality a standard feature, and provide the rest (which only a few will need) through a plugin...

#87 - 2012-09-22 17:17 - Deoren Moor

Jean-Philippe Lang wrote:

this feature will be implemented as a simple flag in 2.2 and visibility configured on each role.

 When you say a flag, are you referring to a flag on the ticket or on each individual comment? My apologies if you've already answered this.

#88 - 2012-09-22 18:20 - Jean-Philippe Lang

Deoren Moor wrote:

When you say a flag, are you referring to a flag on the ticket or on each individual comment? My apologies if you've already answered this.

 On each comment.
#89 - 2012-09-22 23:57 - Daniel Felix

This one would be very helpful! We're thinking about a implementation of redmine in our current workflow and have many tasks where private

comments would solve our problems!

#90 - 2012-09-23 16:41 - Deoren Moor

Jean-Philippe Lang wrote:

Deoren Moor wrote:

When you say a flag, are you referring to a flag on the ticket or on each individual comment? My apologies if you've already answered this.

 On each comment.

 That's awesome. I'm really excited about this feature.

#91 - 2012-09-24 09:39 - Etienne Massip

Just a note about comment numerotation and #2715:

As some comment will be private, there will be gaps in numerotation for users that aren't allowed to see private comments (there must be gaps

because of #2715).

So maybe we can take advantage of this new issue to make this numerotation more consistent?

As it is for now, you can pseudo-delete a comment by specifying an empty text so the comment will not be visible by anyone and numerotation will be

different starting from this comment, thus broking #2715.

Last thing, maybe that the same visibility setting could be used for comments and issue?

#92 - 2012-09-27 20:09 - Brian Lacy

I'm thrilled to hear that 2.2 will include Private Comments! Our team intends to use Redmine as a way to help keep our clients updated, but

sometimes as developers we deal with information that will only confuse (or even unduly alarm) the non-techie types. I do have a quick request,

though:

Can we make "Private" the default value for the flag?

I'd just hate for one of our developers to forget to tick the "Private" box on a client issue and end up complicating an otherwise trivial support issue.

Thanks!

#93 - 2012-09-27 21:39 - Jean-Philippe Lang

Brian Lacy wrote:

Can we make "Private" the default value for the flag?

 This can't be the default behaviour. But we could make it configurable, maybe globally or on a per user or role basis?

#94 - 2012-10-04 23:44 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Feature added in r10547.

#95 - 2012-10-05 08:52 - Abdul Halim Mat Ali

Jean-Philippe Lang, is the revision change stable?

I will love to test the private comment feature.

#96 - 2012-10-05 18:27 - Jean-Philippe Lang

Current trunk is pretty stable. It would nice if you could give it a try before 2.2 release.

#97 - 2012-10-05 18:28 - Jean-Philippe Lang

- % Done changed from 50 to 100
#98 - 2012-10-06 16:19 - Jean-Baptiste Barth

Just tested it, it looks great! I didn't know there was some work going on here, so last week I released a very basic plugin that achieves the same idea

(redmine_comments), but it looks a bit pathetic now ;)  People who need this feature in Redmine 2.1.x can try my plugin though, I'll try to handle the

transition to the core feature as soon as 2.2.0 is out. Thanks for this feature!

#99 - 2012-10-07 19:51 - Etienne Massip

Jean-Philippe Lang wrote:

Brian Lacy wrote:

Can we make "Private" the default value for the flag?

 This can't be the default behaviour. But we could make it configurable, maybe globally or on a per user or role basis?

 Per role would be great and very useful, same for default issue level.

Tested also, nice job indeed. Only remark, the french label associated with the 'Private note' checkbox in the upadte issue form is in plural form.

#100 - 2012-12-03 09:07 - Andrew Kirillov

- File revised_view_private_messages_in_RSS_and_PDF_formats.patch added

This change should fix display issues.

#101 - 2013-08-21 18:08 - Dirk Schmidt

Etienne Massip wrote:

Jean-Philippe Lang wrote:

Brian Lacy wrote:

Can we make "Private" the default value for the flag?

 This can't be the default behaviour. But we could make it configurable, maybe globally or on a per user or role basis?

 Per role would be great and very useful, same for default issue level.

Tested also, nice job indeed. Only remark, the french label associated with the 'Private note' checkbox in the upadte issue form is in plural form.

 +1

#102 - 2014-03-05 17:28 - redmine nemo

I've created a plugin to enforce private notes for a role by default.

See https://github.com/githubnemo/Redmine-Private-Note-Enforcment

#103 - 2014-08-03 09:22 - Etienne Massip

- Has duplicate Feature #1193: Staff-only notes with Role-base access control added

#104 - 2016-08-24 10:49 - Alberto Fanjul Alonso

Only recent versions output if a note is private

https://github.com/redmine/redmine/commit/0e59482e90a788f2da7775a3fb5c51dbea7b135f

#105 - 2019-05-16 12:52 - Go MAEDA

- Has duplicate deleted (Feature #1193: Staff-only notes with Role-base access control)

#106 - 2019-05-16 12:52 - Go MAEDA

- Related to Feature #1193: Staff-only notes with Role-base access control added
patch_output.txt 1.85 KB 2012-01-05 Pablo Bastari
revised_view_private_messages_in_RSS_and_PDF_formats.patch 51 KB 2012-12-03 Andrew Kirillov
